#!/bin/bash
set -e

TAG=e1fe1e1450ae4d9f51bbb04552510ddc56e09956

tar xf org.eclipse.pdt-${TAG}.tar.xz
pushd org.eclipse.pdt-${TAG} &>/dev/null

find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;

for xml in generateAstParser generateCompilerAstParser ; do
  find -name ${xml}.xml -exec sed -i -e 's|classpath=".*"|classpath="/usr/share/java/java_cup.jar"|' {} \;
done
(cd plugins/org.eclipse.php.core/Resources/parserTools/ && ant)

tar -caf code_gen.tar.xz $(find -name ParserConstants.java -o \
                                -name PHPAstLexer.java -o \
                                -name PHPAstParser.java -o \
                                -name DocumentorLexer.java -o \
                                -name CompilerAstParser.java -o \
                                -name CompilerParserConstants.java -o \
                                -name PHPTokenizer.java -o \
                                -name PHPLexer.java)

popd &>/dev/null

mv org.eclipse.pdt-${TAG}/code_gen.tar.xz ./code_gen-${TAG}.tar.xz
